'       Secret of Cooey II
'       The Dark Crystal
'
'       Created by: DarkDread
'
'       Started on: October 12th, 1999
'       Finished on: November 28th, 1999
'
'$INCLUDE: 'soc2.bi'

DECLARE SUB UnloadMIDI (Handle%)
DECLARE SUB StopMIDI ()
DECLARE SUB PlayMIDI (Handle%)
DECLARE SUB LoopMIDI ()
DECLARE SUB CleanUpMIDI ()
DECLARE FUNCTION LoadMIDI% (Filename$)

DECLARE SUB ShowArea ()
DECLARE SUB LoadArea (Area$)
DECLARE SUB LoadTiles (Filename$, TileSet$)
DECLARE SUB MoveCooey (CooeyDir%)
DECLARE SUB ShowCooey ()
DECLARE SUB TopBar ()
DECLARE SUB PutSprite (Filename$, X%, Y%, Number%)
DECLARE SUB LoadData (DataType$)
DECLARE SUB Intro ()
DECLARE SUB TitleScreen ()
DECLARE SUB InitLib ()
DECLARE SUB CooeyMenu ()
DECLARE SUB GetTimePlayed ()
DECLARE SUB DialogBox ()
DECLARE SUB ChoiceBox ()
DECLARE SUB Battle ()
DECLARE SUB Delay (Seconds!)
DECLARE SUB Ending ()
DECLARE SUB ClosingMessage ()

DECLARE SUB BlastPut (dsegment%, doffset%, ssegment%, soffset%, xpos%, ypos%, icol%)
DECLARE SUB BlastPset (segment%, offset%, xpos%, ypos%, col%)
DECLARE SUB BlastPrint (segment%, offset%, xpos%, ypos%, Text$, col%)
DECLARE SUB BlastCopy (fsegment%, foffset%, tsegment%, toffset%)
DECLARE SUB BlastCLS (segment%, offset%, col%)
DECLARE SUB DriversLoaded (SBMIDI%, SBSIM%)

CLEAR , , 5000
DIM SHARED Map%(-1 TO 16, 0 TO 10)
DIM SHARED LevelUp!(1 TO 30)
DIM SHARED Tiles%(10100)
DIM SHARED Cooey%(2424)
DIM SHARED Npcs%(1010)
DIM SHARED Sprite%(10100)
DIM SHARED Buffer%(31999)

DIM SHARED code1%(14), code2%(21), code3%(76), code4%(76), code6%(17)
DIM SHARED ChestArea$(1 TO 22), ChestX%(1 TO 22), ChestY%(1 TO 22), ChestItem$(1 TO 22)

DIM SHARED Magic$(0 TO 4), MagicLvl%(0 TO 4), MagicEx%(0 TO 4)
DIM SHARED Item$(0 TO 4), ItemQnt%(0 TO 4)

DIM SHARED MEM.SEGMENT(0 TO 255) AS INTEGER
DIM SHARED MEM.ALLOCATED(0 TO 255) AS LONG
DIM SHARED BIT.STORAGE(0 TO 7) AS INTEGER

CLS
RANDOMIZE TIMER
COLOR 15, 4
PRINT "                             SOC2-SYS Version 1.1                               "
COLOR 15, 0
PRINT "Init MIDI..."
DriversLoaded SBMIDI.INTERRUPT, SBSIM.INTERRUPT
IF SBMIDI.INTERRUPT THEN
        PRINT "Driver deteceted at "; HEX$(SBMIDI.INTERRUPT); "h..."
    ELSE
        PRINT "MIDI drivers not loaded! Please use start.bat to play..."
        WHILE INKEY$ = "": WEND
        SYSTEM
END IF
IF SBMIDI.INTERRUPT = 0 THEN SBMIDI.INTERRUPT = &H80
IF SBSIM.INTERRUPT = 0 THEN SBSIM.INTERRUPT = &H81
PRINT "Init Blast!..."
InitLib
PRINT "Init tile data..."
LoadTiles "cooey.set", "cooey"
LoadTiles "npcs.set", "npcs"
LoadTiles "town.set", "tiles"
PRINT "Init stats..."
LoadData "levelup.dat"
CurrentArea$ = "town1.map"
LoadArea CurrentArea$
PRINT
PRINT "+------------------------------------------------------------------------------+"
PRINT "| The Secret of Cooey II: The Dark Crystal                                     |"
PRINT "| A freeware RPG by DarkDread                                                  |"
PRINT "| Please see the readme.txt file for more instructions.                        |"
PRINT "| Now, press any key to begin the game...                                      |"
PRINT "|                                                                              |"
PRINT "| Visit me: http://www.geocities.com/TimesSquare/Ring/1683                     |"
PRINT "| E-mail me: darkdread@hotmail.com                                             |"
PRINT "+------------------------------------------------------------------------------+"
WHILE INKEY$ = "": WEND
COLOR 7

SCREEN 13
Intro
TitleScreen

MIDIHandle% = LoadMIDI("TOWN.MID")
PlayMIDI MIDIHandle%
TopBar
ShowArea
ShowCooey
BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0

DO

    SELECT CASE INKEY$
    CASE CHR$(0) + CHR$(72)
        CooeyDir% = 0: Moved% = True: TalkTo$ = ""
        IF CooeyY% > 1 THEN
                IF CurrentArea$ = "town2.map" AND CooeyX% = 12 AND CooeyY% = 4 THEN
                        TalkTo$ = "Julia"
                    ELSEIF CurrentArea$ = "town2.map" AND CooeyX% = 11 AND CooeyY% = 4 THEN
                        TalkTo$ = "Mattress"
                    ELSEIF CurrentArea$ = "town3.map" AND CooeyX% = 7 AND CooeyY% = 5 THEN
                        TalkTo$ = "Dopey"
                    ELSEIF CurrentArea$ = "town4.map" AND CooeyX% = 5 AND CooeyY% = 5 THEN
                        TalkTo$ = "Harley"
                    ELSEIF CurrentArea$ = "town4.map" AND CooeyX% = 9 AND CooeyY% = 4 THEN
                        TalkTo$ = "James"
                    ELSEIF CurrentArea$ = "town1.map" AND CooeyX% = 9 AND CooeyY% = 4 THEN
                        TalkTo$ = "Cooey"
                    ELSEIF CurrentArea$ = "f1_5.map" AND CooeyStory% = 1 AND CooeyX% = 7 AND CooeyY% = 7 THEN
                        TalkTo$ = "Angelust"
                    ELSEIF CurrentArea$ = "f2_1.map" AND CooeyStory% = 2 AND CooeyX% = 11 AND CooeyY% = 4 THEN
                        TalkTo$ = "Soulrape"
                    ELSEIF CurrentArea$ = "f3_4.map" AND CooeyStory% = 3 AND CooeyX% = 4 AND CooeyY% = 4 THEN
                        TalkTo$ = "Odin"
                    ELSEIF CurrentArea$ = "f4_3.map" AND CooeyStory% = 4 AND CooeyX% = 8 AND CooeyY% = 4 THEN
                        TalkTo$ = "Urobulus"
                    ELSEIF CurrentArea$ = "f4_4.map" AND CooeySecret% = 0 AND CooeyX% = 7 AND CooeyY% = 4 THEN
                        TalkTo$ = "Cain"
                    ELSEIF CurrentArea$ = "f5_3.map" AND CooeyStory% = 5 AND CooeyX% = 7 AND CooeyY% = 6 THEN
                        TalkTo$ = "Genesis God"
                    ELSE
                        IF Map(CooeyX%, CooeyY% - 1) < 29 THEN MoveCooey CooeyDir%
                END IF
                IF CurrentArea$ = "town2.map" AND CooeyX% = 12 AND CooeyY% = 4 THEN
                        TalkTo$ = "Julia"
                    ELSEIF CurrentArea$ = "town3.map" AND CooeyX% = 7 AND CooeyY% = 5 THEN
                        TalkTo$ = "Dopey"
                    ELSEIF CurrentArea$ = "town4.map" AND CooeyX% = 9 AND CooeyY% = 4 THEN
                        TalkTo$ = "James"
                    ELSEIF CurrentArea$ = "town1.map" AND CooeyX% = 9 AND CooeyY% = 4 THEN
                        TalkTo$ = "Cooey"
                    ELSEIF CurrentArea$ = "f1_5.map" AND CooeyStory% = 1 AND CooeyX% = 7 AND CooeyY% = 7 THEN
                        TalkTo$ = "Angelust"
                    ELSEIF CurrentArea$ = "f2_1.map" AND CooeyStory% = 2 AND CooeyX% = 11 AND CooeyY% = 4 THEN
                        TalkTo$ = "Soulrape"
                    ELSEIF CurrentArea$ = "f3_4.map" AND CooeyStory% = 3 AND CooeyX% = 4 AND CooeyY% = 3 THEN
                        TalkTo$ = "Odin"
                    ELSEIF CurrentArea$ = "f4_3.map" AND CooeyStory% = 4 AND CooeyX% = 8 AND CooeyY% = 4 THEN
                        TalkTo$ = "Urobulus"
                    ELSEIF CurrentArea$ = "f4_4.map" AND CooeySecret% = 0 AND CooeyX% = 7 AND CooeyY% = 4 THEN
                        TalkTo$ = "Cain"
                    ELSEIF CurrentArea$ = "f5_3.map" AND CooeyStory% = 5 AND CooeyX% = 7 AND CooeyY% = 6 THEN
                        TalkTo$ = "Genesis God"
                END IF
                IF CurrentArea$ = "cliffs3.map" AND Map%(CooeyX%, CooeyY%) = 9 THEN
                        StopMIDI
                        UnloadMIDI MIDIHandle%
                        MIDIHandle% = LoadMIDI("TOWER_F1.MID")
                        PlayMIDI MIDIHandle%
                        CurrentArea$ = "f1_2.map"
                        LoadTiles "tower_f1.set", "tiles"
                        CooeyY% = 9: TopBar
                        LoadArea CurrentArea$
                    ELSEIF CurrentArea$ = "f1_5.map" AND Map%(CooeyX%, CooeyY%) = 3 THEN
                        CurrentArea$ = "f2_3.map"
                        CooeyY% = 4: TopBar
                        LoadArea CurrentArea$
                    ELSEIF CurrentArea$ = "f2_3.map" AND Map%(CooeyX%, CooeyY%) = 4 THEN
                        CurrentArea$ = "f1_5.map"
                        CooeyY% = 6: TopBar
                        LoadArea CurrentArea$
                    ELSEIF CurrentArea$ = "f2_1.map" AND Map%(CooeyX%, CooeyY%) = 3 THEN
                        CurrentArea$ = "f3_1.map"
                        CooeyY% = 4: CooeyX% = 7: TopBar
                        LoadArea CurrentArea$
                    ELSEIF CurrentArea$ = "f3_1.map" AND Map%(CooeyX%, CooeyY%) = 4 THEN
                        CurrentArea$ = "f2_1.map"
                        CooeyY% = 4: CooeyX% = 11: TopBar
                        LoadArea CurrentArea$
                    ELSEIF CurrentArea$ = "f4_6.map" AND Map%(CooeyX%, CooeyY%) = 4 THEN
                        StopMIDI
                        UnloadMIDI MIDIHandle%
                        MIDIHandle% = LoadMIDI("TOWER_F1.MID")
                        PlayMIDI MIDIHandle%
                        CurrentArea$ = "f3_4.map"
                        LoadTiles "tower_f1.set", "tiles"
                        CooeyY% = 3: TopBar
                        LoadArea CurrentArea$
                    ELSEIF CurrentArea$ = "f3_4.map" AND Map%(CooeyX%, CooeyY%) = 3 THEN
                        StopMIDI
                        UnloadMIDI MIDIHandle%
                        MIDIHandle% = LoadMIDI("TOWER_F4.MID")
                        PlayMIDI MIDIHandle%
                        CurrentArea$ = "f4_6.map"
                        LoadTiles "tower_f4.set", "tiles"
                        CooeyY% = 3: TopBar
                        LoadArea CurrentArea$
                    ELSEIF CurrentArea$ = "f5_1.map" AND Map%(CooeyX%, CooeyY%) = 4 THEN
                        CurrentArea$ = "f4_3.map"
                        CooeyY% = 3: TopBar
                        LoadArea CurrentArea$
                    ELSEIF CurrentArea$ = "f4_3.map" AND Map%(CooeyX%, CooeyY%) = 3 THEN
                        CurrentArea$ = "f5_1.map"
                        CooeyY% = 3: TopBar
                        LoadArea CurrentArea$
                END IF
            ELSE
                IF CurrentArea$ = "town3.map" THEN
                        CurrentArea$ = "town1.map"
                    ELSEIF CurrentArea$ = "town1.map" THEN
                        StopMIDI
                        UnloadMIDI MIDIHandle%
                        MIDIHandle% = LoadMIDI("FOREST.MID")
                        PlayMIDI MIDIHandle%
                        CurrentArea$ = "forest1.map"
                    ELSEIF CurrentArea$ = "forest1.map" THEN
                        CurrentArea$ = "forest2.map"
                    ELSEIF CurrentArea$ = "cliffs2.map" THEN
                        CurrentArea$ = "cliffs3.map"
                    ELSEIF CurrentArea$ = "f1_1.map" THEN
                        CurrentArea$ = "f1_4.map"
                    ELSEIF CurrentArea$ = "f1_3.map" THEN
                        CurrentArea$ = "f1_6.map"
                    ELSEIF CurrentArea$ = "f1_4.map" THEN
                        CurrentArea$ = "f1_7.map"
                    ELSEIF CurrentArea$ = "f1_5.map" THEN
                        CurrentArea$ = "f1_8.map"
                    ELSEIF CurrentArea$ = "f1_6.map" THEN
                        CurrentArea$ = "f1_9.map"
                    ELSEIF CurrentArea$ = "f2_1.map" THEN
                        CurrentArea$ = "f2_3.map"
                    ELSEIF CurrentArea$ = "f2_2.map" THEN
                        CurrentArea$ = "f2_5.map"
                    ELSEIF CurrentArea$ = "f2_4.map" THEN
                        CurrentArea$ = "f2_7.map"
                    ELSEIF CurrentArea$ = "f3_1.map" THEN
                        CurrentArea$ = "f3_3.map"
                    ELSEIF CurrentArea$ = "f4_2.map" THEN
                        CurrentArea$ = "f4_5.map"
                    ELSEIF CurrentArea$ = "f4_1.map" THEN
                        CurrentArea$ = "f4_4.map"
                    ELSEIF CurrentArea$ = "f5_1.map" THEN
                        CurrentArea$ = "f5_2.map"
                    ELSEIF CurrentArea$ = "f5_2.map" THEN
                        CurrentArea$ = "f5_3.map"
                END IF
                CooeyY% = 9: TopBar
                LoadArea CurrentArea$
        END IF
    CASE CHR$(0) + CHR$(80)
        CooeyDir% = 1: Moved% = True: TalkTo$ = ""
        IF CooeyY% < 9 THEN
                IF Map(CooeyX%, CooeyY% + 1) < 29 THEN MoveCooey CooeyDir%
            ELSE
                CooeyY% = 1: TopBar
                IF CurrentArea$ = "town1.map" THEN
                        CurrentArea$ = "town3.map"
                    ELSEIF CurrentArea$ = "forest1.map" THEN
                        StopMIDI
                        UnloadMIDI MIDIHandle%
                        MIDIHandle% = LoadMIDI("TOWN.MID")
                        PlayMIDI MIDIHandle%
                        CurrentArea$ = "town1.map"
                    ELSEIF CurrentArea$ = "forest2.map" THEN
                        CurrentArea$ = "forest1.map"
                    ELSEIF CurrentArea$ = "cliffs3.map" THEN
                        CurrentArea$ = "cliffs2.map"
                    ELSEIF CurrentArea$ = "f1_2.map" THEN
                        StopMIDI
                        UnloadMIDI MIDIHandle%
                        MIDIHandle% = LoadMIDI("MOUNTAIN.MID")
                        PlayMIDI MIDIHandle%
                        LoadTiles "cliffs.set", "tiles"
                        CurrentArea$ = "cliffs3.map"
                        CooeyY% = 5
                    ELSEIF CurrentArea$ = "f1_4.map" THEN
                        CurrentArea$ = "f1_1.map"
                    ELSEIF CurrentArea$ = "f1_6.map" THEN
                        CurrentArea$ = "f1_3.map"
                    ELSEIF CurrentArea$ = "f1_7.map" THEN
                        CurrentArea$ = "f1_4.map"
                    ELSEIF CurrentArea$ = "f1_8.map" THEN
                        CurrentArea$ = "f1_5.map"
                    ELSEIF CurrentArea$ = "f1_9.map" THEN
                        CurrentArea$ = "f1_6.map"
                    ELSEIF CurrentArea$ = "f2_3.map" THEN
                        CurrentArea$ = "f2_1.map"
                    ELSEIF CurrentArea$ = "f2_5.map" THEN
                        CurrentArea$ = "f2_2.map"
                    ELSEIF CurrentArea$ = "f2_7.map" THEN
                        CurrentArea$ = "f2_4.map"
                    ELSEIF CurrentArea$ = "f3_3.map" THEN
                        CurrentArea$ = "f3_1.map"
                    ELSEIF CurrentArea$ = "f4_5.map" THEN
                        CurrentArea$ = "f4_2.map"
                    ELSEIF CurrentArea$ = "f4_4.map" THEN
                        CurrentArea$ = "f4_1.map"
                    ELSEIF CurrentArea$ = "f5_3.map" THEN
                        CurrentArea$ = "f5_2.map"
                    ELSEIF CurrentArea$ = "f5_2.map" THEN
                        CurrentArea$ = "f5_1.map"
                END IF
                LoadArea CurrentArea$
        END IF
    CASE CHR$(0) + CHR$(75)
        CooeyDir% = 2: Moved% = True: TalkTo$ = ""
        IF CooeyX% > 0 THEN
                IF Map(CooeyX% - 1, CooeyY%) < 29 THEN MoveCooey CooeyDir%
            ELSE
                IF CurrentArea$ = "town2.map" THEN
                        CurrentArea$ = "town1.map"
                    ELSEIF CurrentArea$ = "town4.map" THEN
                        CurrentArea$ = "town3.map"
                    ELSEIF CurrentArea$ = "cliffs1.map" THEN
                        LoadTiles "town.set", "tiles"
                        StopMIDI
                        UnloadMIDI MIDIHandle%
                        MIDIHandle% = LoadMIDI("FOREST.MID")
                        PlayMIDI MIDIHandle%
                        CurrentArea$ = "forest2.map"
                    ELSEIF CurrentArea$ = "cliffs2.map" THEN
                        CurrentArea$ = "cliffs1.map"
                    ELSEIF CurrentArea$ = "f1_2.map" THEN
                        CurrentArea$ = "f1_1.map"
                    ELSEIF CurrentArea$ = "f1_3.map" THEN
                        CurrentArea$ = "f1_2.map"
                    ELSEIF CurrentArea$ = "f1_9.map" THEN
                        CurrentArea$ = "f1_8.map"
                    ELSEIF CurrentArea$ = "f1_8.map" THEN
                        CurrentArea$ = "f1_7.map"
                    ELSEIF CurrentArea$ = "f2_4.map" THEN
                        CurrentArea$ = "f2_3.map"
                    ELSEIF CurrentArea$ = "f2_3.map" THEN
                        CurrentArea$ = "f2_2.map"
                    ELSEIF CurrentArea$ = "f2_7.map" THEN
                        CurrentArea$ = "f2_6.map"
                    ELSEIF CurrentArea$ = "f2_6.map" THEN
                        CurrentArea$ = "f2_5.map"
                    ELSEIF CurrentArea$ = "f3_4.map" THEN
                        CurrentArea$ = "f3_3.map"
                    ELSEIF CurrentArea$ = "f3_3.map" THEN
                        CurrentArea$ = "f3_2.map"
                    ELSEIF CurrentArea$ = "f4_6.map" THEN
                        CurrentArea$ = "f4_5.map"
                    ELSEIF CurrentArea$ = "f4_3.map" THEN
                        CurrentArea$ = "f4_2.map"
                    ELSEIF CurrentArea$ = "f4_2.map" THEN
                        StopMIDI
                        UnloadMIDI MIDIHandle%
                        MIDIHandle% = LoadMIDI("SECRET.MID")
                        PlayMIDI MIDIHandle%
                        LoadTiles "secret.set", "tiles"
                        CurrentArea$ = "f4_1.map"
                END IF
                CooeyX% = 15: TopBar
                LoadArea CurrentArea$
        END IF
    CASE CHR$(0) + CHR$(77)
        CooeyDir% = 3: Moved% = True: TalkTo$ = ""
        IF CooeyX% < 15 THEN
                IF CurrentArea$ = "cliffs1.map" AND CooeyX% = 14 AND CooeyY% = 5 AND CooeyStory% = 0 THEN
                        TalkTo$ = "Dark Knight"
                    ELSE
                        IF Map(CooeyX% + 1, CooeyY%) < 29 THEN MoveCooey CooeyDir%
                END IF
                IF CurrentArea$ = "cliffs1.map" AND CooeyX% = 14 AND CooeyY% = 5 AND CooeyStory% = 0 THEN
                        TalkTo$ = "Dark Knight"
                END IF
            ELSE
                IF CurrentArea$ = "town1.map" THEN
                        CurrentArea$ = "town2.map"
                    ELSEIF CurrentArea$ = "town3.map" THEN
                        CurrentArea$ = "town4.map"
                    ELSEIF CurrentArea$ = "forest2.map" THEN
                        StopMIDI
                        UnloadMIDI MIDIHandle%
                        MIDIHandle% = LoadMIDI("MOUNTAIN.MID")
                        PlayMIDI MIDIHandle%
                        LoadTiles "cliffs.set", "tiles"
                        CurrentArea$ = "cliffs1.map"
                    ELSEIF CurrentArea$ = "cliffs1.map" THEN
                        CurrentArea$ = "cliffs2.map"
                    ELSEIF CurrentArea$ = "f1_1.map" THEN
                        CurrentArea$ = "f1_2.map"
                    ELSEIF CurrentArea$ = "f1_2.map" THEN
                        CurrentArea$ = "f1_3.map"
                    ELSEIF CurrentArea$ = "f1_7.map" THEN
                        CurrentArea$ = "f1_8.map"
                    ELSEIF CurrentArea$ = "f1_8.map" THEN
                        CurrentArea$ = "f1_9.map"
                    ELSEIF CurrentArea$ = "f2_2.map" THEN
                        CurrentArea$ = "f2_3.map"
                    ELSEIF CurrentArea$ = "f2_3.map" THEN
                        CurrentArea$ = "f2_4.map"
                    ELSEIF CurrentArea$ = "f2_5.map" THEN
                        CurrentArea$ = "f2_6.map"
                    ELSEIF CurrentArea$ = "f2_6.map" THEN
                        CurrentArea$ = "f2_7.map"
                    ELSEIF CurrentArea$ = "f3_2.map" THEN
                        CurrentArea$ = "f3_3.map"
                    ELSEIF CurrentArea$ = "f3_3.map" THEN
                        CurrentArea$ = "f3_4.map"
                    ELSEIF CurrentArea$ = "f4_5.map" THEN
                        CurrentArea$ = "f4_6.map"
                    ELSEIF CurrentArea$ = "f4_2.map" THEN
                        CurrentArea$ = "f4_3.map"
                    ELSEIF CurrentArea$ = "f4_1.map" THEN
                        StopMIDI
                        UnloadMIDI MIDIHandle%
                        MIDIHandle% = LoadMIDI("TOWER_F4.MID")
                        PlayMIDI MIDIHandle%
                        LoadTiles "tower_f4.set", "tiles"
                        CurrentArea$ = "f4_2.map"
                END IF
                CooeyX% = 0: TopBar
                LoadArea CurrentArea$
        END IF
    CASE CHR$(13)
        Moved% = True: ChestThere% = False: GotChest% = False
        IF CooeyDir% = 0 THEN
                IF Map%(CooeyX%, CooeyY% - 1) = 43 THEN
                    FOR I = 1 TO 22
                        IF GotChest% THEN EXIT FOR
                        IF CooeyX% = ChestX%(I) AND CooeyY% - 1 = ChestY%(I) AND CurrentArea$ = ChestArea$(I) AND ChestItem$(I) <> "" THEN
                            ChestThere% = True
                            IF ChestItem$(I) = "Herb" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an Herb in the chest.    "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(0) < 9 THEN
                                            Item$(0) = "Herb": ItemQnt%(0) = ItemQnt%(0) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the Herb!               "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more Herbs! "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "X Herb" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an X Herb in the chest.  "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(1) < 9 THEN
                                            Item$(1) = "X Herb": ItemQnt%(1) = ItemQnt%(1) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the X Herb!             "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more        "
                                            LOCATE 20, 4: PRINT "X Herbs!"
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "Ether" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an Ether in the chest.   "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(2) < 9 THEN
                                            Item$(2) = "Ether": ItemQnt%(2) = ItemQnt%(2) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the Ether!              "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more Ether! "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "X Ether" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an X Ether in the chest. "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(3) < 9 THEN
                                            Item$(3) = "X Ether": ItemQnt%(3) = ItemQnt%(3) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the X Ether!            "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more        "
                                            LOCATE 20, 4: PRINT "X Ether!                          "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "Angel Wing" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an Angel Wing in the     "
                                    LOCATE 20, 4: PRINT "chest.                            "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(4) < 9 THEN
                                            Item$(4) = "Angel Wing": ItemQnt%(4) = ItemQnt%(4) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the Angel Wing!         "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more        "
                                            LOCATE 20, 4: PRINT "Angel Wings!                      "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "Long Sword" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is a Long Sword in the      "
                                    LOCATE 20, 4: PRINT "chest.                            "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF Weapon$ = "Fists" OR Weapon$ = "Short Sword" THEN
                                            ChestItem$(I) = "": GotChest% = True
                                            IF Weapon$ = "Fists" THEN
                                                    ST% = ST% + 7
                                                ELSEIF Weapon$ = "Short Sword" THEN
                                                    ST% = ST% + 5
                                            END IF
                                            Weapon$ = "Long Sword"
                                            LOCATE 19, 4: PRINT "Cooey got the Long Sword!         "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey already has a better weapon."
                                            LOCATE 20, 4: PRINT "He doesn't need this one.         "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "Katana" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is a Katana in the chest.   "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF Weapon$ = "Fists" OR Weapon$ = "Short Sword" OR Weapon$ = "Long Sword" OR Weapon$ = "Bastard Sword" THEN
                                            ChestItem$(I) = "": GotChest% = True
                                            IF Weapon$ = "Fists" THEN
                                                    ST% = ST% + 59
                                                ELSEIF Weapon$ = "Short Sword" THEN
                                                    ST% = ST% + 57
                                                ELSEIF Weapon$ = "Long Sword" THEN
                                                    ST% = ST% + 52
                                                ELSEIF Weapon$ = "Bastard Sword" THEN
                                                    ST% = ST% + 35
                                            END IF
                                            Weapon$ = "Katana"
                                            LOCATE 19, 4: PRINT "Cooey got the Katana!             "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey already has a better weapon."
                                            LOCATE 20, 4: PRINT "He doesn't need this one.         "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "Dark Armor" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is Dark Armor in the chest. "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF Armor$ <> "" THEN
                                            ChestItem$(I) = "": GotChest% = True
                                            IF Armor$ = "Clothes" THEN
                                                    DF% = DF% + 140: MD% = MD% + 100
                                                ELSEIF Armor$ = "Chain Suit" THEN
                                                    DF% = DF% + 139: MD% = MD% + 100
                                                ELSEIF Armor$ = "Spiked Armor" THEN
                                                    DF% = DF% + 135: MD% = MD% + 100
                                                ELSEIF Armor$ = "Scale Suit" THEN
                                                    DF% = DF% + 115: MD% = MD% + 100
                                                ELSEIF Armor$ = "Ancient Armor" THEN
                                                    DF% = DF% + 75: MD% = MD% + 100
                                            END IF
                                            Armor$ = "Dark Armor"
                                            LOCATE 19, 4: PRINT "Cooey got the Dark Armor!         "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey already has better armor.   "
                                            LOCATE 20, 4: PRINT "He doesn't need this.             "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                            END IF
                        END IF
                    NEXT I
                END IF
            ELSEIF CooeyDir% = 2 THEN
                IF Map%(CooeyX% - 1, CooeyY%) = 43 THEN
                    FOR I = 1 TO 22
                        IF GotChest% THEN EXIT FOR
                        IF CooeyX% - 1 = ChestX%(I) AND CooeyY% = ChestY%(I) AND CurrentArea$ = ChestArea$(I) AND ChestItem$(I) <> "" THEN
                            ChestThere% = True
                            IF ChestItem$(I) = "Herb" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an Herb in the chest.    "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(0) < 9 THEN
                                            Item$(0) = "Herb": ItemQnt%(0) = ItemQnt%(0) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the Herb!               "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more Herbs! "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "X Herb" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an X Herb in the chest.  "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(1) < 9 THEN
                                            Item$(1) = "X Herb": ItemQnt%(1) = ItemQnt%(1) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the X Herb!             "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more        "
                                            LOCATE 20, 4: PRINT "X Herbs!"
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "Ether" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an Ether in the chest.   "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(2) < 9 THEN
                                            Item$(2) = "Ether": ItemQnt%(2) = ItemQnt%(2) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the Ether!              "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more Ether! "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "X Ether" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an X Ether in the chest. "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(3) < 9 THEN
                                            Item$(3) = "X Ether": ItemQnt%(3) = ItemQnt%(3) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the X Ether!            "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more        "
                                            LOCATE 20, 4: PRINT "X Ether!                          "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "Angel Wing" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an Angel Wing in the     "
                                    LOCATE 20, 4: PRINT "chest.                            "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(4) < 9 THEN
                                            Item$(4) = "Angel Wing": ItemQnt%(4) = ItemQnt%(4) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the Angel Wing!         "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more        "
                                            LOCATE 20, 4: PRINT "Angel Wings!                      "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "Bastard Sword" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is a Bastard Sword in the   "
                                    LOCATE 20, 4: PRINT "chest.                            "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF Weapon$ = "Fists" OR Weapon$ = "Short Sword" OR Weapon$ = "Long Sword" THEN
                                            ChestItem$(I) = "": GotChest% = True
                                            IF Weapon$ = "Fists" THEN
                                                    ST% = ST% + 24
                                                ELSEIF Weapon$ = "Short Sword" THEN
                                                    ST% = ST% + 22
                                                ELSEIF Weapon$ = "Long Sword" THEN
                                                    ST% = ST% + 17
                                            END IF
                                            Weapon$ = "Bastard Sword"
                                            LOCATE 19, 4: PRINT "Cooey got the Bastard Sword!      "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey already has a better weapon."
                                            LOCATE 20, 4: PRINT "He doesn't need this one.         "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "Ancient Sword" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an Ancient Sword in the  "
                                    LOCATE 20, 4: PRINT "chest.                            "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF Weapon$ <> "Dark Sword" THEN
                                            ChestItem$(I) = "": GotChest% = True
                                            IF Weapon$ = "Fists" THEN
                                                    ST% = ST% + 109
                                                ELSEIF Weapon$ = "Short Sword" THEN
                                                    ST% = ST% + 107
                                                ELSEIF Weapon$ = "Long Sword" THEN
                                                    ST% = ST% + 102
                                                ELSEIF Weapon$ = "Bastard Sword" THEN
                                                    ST% = ST% + 85
                                                ELSEIF Weapon$ = "Katana" THEN
                                                    ST% = ST% + 50
                                            END IF
                                            Weapon$ = "Ancient Sword"
                                            LOCATE 19, 4: PRINT "Cooey got the Ancient Sword!      "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey already has a better weapon."
                                            LOCATE 20, 4: PRINT "He doesn't need this one.         "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "Spiked Armor" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is Spiked Armor in the      "
                                    LOCATE 20, 4: PRINT "chest.                            "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF Armor$ = "Clothes" OR Armor$ = "Chain Suit" THEN
                                            ChestItem$(I) = "": GotChest% = True
                                            IF Armor$ = "Clothes" THEN
                                                    DF% = DF% + 5
                                                ELSEIF Armor$ = "Chain Suit" THEN
                                                    DF% = DF% + 4
                                            END IF
                                            Armor$ = "Spiked Armor"
                                            LOCATE 19, 4: PRINT "Cooey got the Spiked Armor!       "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey already has better armor.   "
                                            LOCATE 20, 4: PRINT "He doesn't need this.             "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                            END IF
                        END IF
                    NEXT I
                END IF
            ELSEIF CooeyDir% = 3 THEN
                IF Map%(CooeyX% + 1, CooeyY%) = 43 THEN
                    FOR I = 1 TO 22
                        IF GotChest% THEN EXIT FOR
                        IF CooeyX% + 1 = ChestX%(I) AND CooeyY% = ChestY%(I) AND CurrentArea$ = ChestArea$(I) AND ChestItem$(I) <> "" THEN
                            ChestThere% = True
                            IF ChestItem$(I) = "Herb" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an Herb in the chest.    "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(0) < 9 THEN
                                            Item$(0) = "Herb": ItemQnt%(0) = ItemQnt%(0) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the Herb!               "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more Herbs! "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "X Herb" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an X Herb in the chest.  "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(1) < 9 THEN
                                            Item$(1) = "X Herb": ItemQnt%(1) = ItemQnt%(1) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the X Herb!             "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more        "
                                            LOCATE 20, 4: PRINT "X Herbs!"
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "Ether" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an Ether in the chest.   "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(2) < 9 THEN
                                            Item$(2) = "Ether": ItemQnt%(2) = ItemQnt%(2) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the Ether!              "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more Ether! "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "X Ether" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an X Ether in the chest. "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(3) < 9 THEN
                                            Item$(3) = "X Ether": ItemQnt%(3) = ItemQnt%(3) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the X Ether!            "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more        "
                                            LOCATE 20, 4: PRINT "X Ether!                          "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "Angel Wing" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is an Angel Wing in the     "
                                    LOCATE 20, 4: PRINT "chest.                            "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF ItemQnt%(4) < 9 THEN
                                            Item$(4) = "Angel Wing": ItemQnt%(4) = ItemQnt%(4) + 1: ChestItem$(I) = "": GotChest% = True
                                            LOCATE 19, 4: PRINT "Cooey got the Angel Wing!         "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey can't carry any more        "
                                            LOCATE 20, 4: PRINT "Angel Wings!                      "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "Scale Suit" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is a Scale Suit in the      "
                                    LOCATE 20, 4: PRINT "chest.                            "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF Armor$ = "Clothes" OR Armor$ = "Chain Suit" OR Armor$ = "Spiked Armor" THEN
                                            ChestItem$(I) = "": GotChest% = True
                                            IF Armor$ = "Clothes" THEN
                                                    DF% = DF% + 25
                                                ELSEIF Armor$ = "Chain Suit" THEN
                                                    DF% = DF% + 24
                                                ELSEIF Armor$ = "Spiked Armor" THEN
                                                    DF% = DF% + 20
                                            END IF
                                            Armor$ = "Scale Suit"
                                            LOCATE 19, 4: PRINT "Cooey got the Scale Suit!         "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey already has better armor.   "
                                            LOCATE 20, 4: PRINT "He doesn't need this.             "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                                ELSEIF ChestItem$(I) = "Ancient Armor" THEN
                                    DialogBox
                                    LOCATE 19, 4: PRINT "There is Ancient Armor in the     "
                                    LOCATE 20, 4: PRINT "chest.                            "
                                    WHILE INKEY$ = "": LoopMIDI: WEND
                                    DialogBox
                                    IF Armor$ <> "Dark Armor" THEN
                                            ChestItem$(I) = "": GotChest% = True
                                            IF Armor$ = "Clothes" THEN
                                                    DF% = DF% + 65
                                                ELSEIF Armor$ = "Chain Suit" THEN
                                                    DF% = DF% + 64
                                                ELSEIF Armor$ = "Spiked Armor" THEN
                                                    DF% = DF% + 60
                                                ELSEIF Armor$ = "Scale Suit" THEN
                                                    DF% = DF% + 40
                                            END IF
                                            Armor$ = "Ancient Armor"
                                            LOCATE 19, 4: PRINT "Cooey got the Ancient Armor!      "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                        ELSE
                                            LOCATE 19, 4: PRINT "Cooey already has better armor.   "
                                            LOCATE 20, 4: PRINT "He doesn't need this.             "
                                            WHILE INKEY$ = "": LoopMIDI: WEND
                                    END IF
                            END IF
                        END IF
                    NEXT I
                END IF
        END IF
        IF TalkTo$ = "" AND NOT ChestThere% THEN
                CooeyMenu
            ELSEIF TalkTo$ = "Mattress" THEN
                DialogBox
                LOCATE 19, 4: PRINT "Mattress:"
                LOCATE 20, 4: PRINT "Hey Cooey.  How goes it?          "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "Fine, fine... Uhm... How'd you    "
                LOCATE 21, 4: PRINT "survive through the last game?    "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Mattress:"
                LOCATE 20, 4: PRINT "Simple... I used an elixir to     "
                LOCATE 21, 4: PRINT "revive myself.                    "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "Okay... That makes sense... I     "
                LOCATE 21, 4: PRINT "think...                          "
                WHILE INKEY$ = "": LoopMIDI: WEND
                IF Armor$ = "Clothes" THEN
                        DialogBox
                        LOCATE 19, 4: PRINT "Mattress:"
                        LOCATE 20, 4: PRINT "Oh, here... Take this Chain Suit. "
                        Armor$ = "Chain Suit"
                        DF% = DF% + 1
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Mattress:"
                        LOCATE 20, 4: PRINT "I have no use for it... and it'll "
                        LOCATE 21, 4: PRINT "give you better protection than   "
                        LOCATE 22, 4: PRINT "your shirt.                       "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Cooey:"
                        LOCATE 20, 4: PRINT "Hey, thanks!                      "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                END IF
            ELSEIF TalkTo$ = "Julia" THEN
                DialogBox
                LOCATE 19, 4: PRINT "Julia:"
                LOCATE 20, 4: PRINT "Going on another quest Cooey?     "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Julia:"
                LOCATE 20, 4: PRINT "Well... Good luck.  We'll be here "
                LOCATE 21, 4: PRINT "to help when you need us.         "
                WHILE INKEY$ = "": LoopMIDI: WEND
                IF Weapon$ = "Fists" THEN
                        DialogBox
                        LOCATE 19, 4: PRINT "Julia:"
                        LOCATE 20, 4: PRINT "Oh, I almost forgot.              "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Julia:"
                        LOCATE 20, 4: PRINT "Take this Short Sword.  It's not  "
                        LOCATE 21, 4: PRINT "much of a weapon... But, better   "
                        LOCATE 22, 4: PRINT "than nothing.                     "
                        Weapon$ = "Short Sword"
                        ST% = ST% + 2
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Cooey:"
                        LOCATE 20, 4: PRINT "Thanks... It'll help.             "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                END IF
            ELSEIF TalkTo$ = "Dopey" THEN
                DialogBox
                LOCATE 19, 4: PRINT "Dopey:"
                LOCATE 20, 4: PRINT "Hey Cooey.  I'm in this game now! "
                LOCATE 21, 4: PRINT "Aren't you happy?                 "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "No... Err... I mean, maybe... ah, "
                LOCATE 21, 4: PRINT "I mean yes... Yeah, that's it.    "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "Anyway, what happened to Meg?     "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Dopey:"
                LOCATE 20, 4: PRINT "She fell into a lost cluster.  So "
                LOCATE 21, 4: PRINT "we ran ScanDisk on her, and uhm..."
                LOCATE 22, 4: PRINT "deleted her.                      "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "Good riddance to that. She would  "
                LOCATE 21, 4: PRINT "not have fit with the gothic theme"
                LOCATE 22, 4: PRINT "of this sequel.                   "
                WHILE INKEY$ = "": LoopMIDI: WEND
            ELSEIF TalkTo$ = "Harley" THEN
                IF CooeyStory% = 0 THEN
                        DialogBox
                        LOCATE 19, 4: PRINT "Harley:"
                        LOCATE 20, 4: PRINT "Hey Cooey, wanna know what's new  "
                        LOCATE 21, 4: PRINT "from your last adventure?         "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Cooey:"
                        LOCATE 20, 4: PRINT "Uhm... You're not going to try to "
                        LOCATE 21, 4: PRINT "sell me items in exchange for cat "
                        LOCATE 22, 4: PRINT "food are you?                     "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Harley:"
                        LOCATE 20, 4: PRINT "No.  What do you think this is?   "
                        LOCATE 21, 4: PRINT "Dark Crown?                       "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Cooey:"
                        LOCATE 20, 4: PRINT "Sorry.  Just making sure.         "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Harley:"
                        LOCATE 20, 4: PRINT "Fine.  Tell you what... Go defeat "
                        LOCATE 21, 4: PRINT "the Dark Knight, then come back   "
                        LOCATE 22, 4: PRINT "and we'll talk.                   "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Harley:"
                        LOCATE 20, 4: PRINT "Oh, but before that, I will give  "
                        LOCATE 21, 4: PRINT "you one hint.                     "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Harley:"
                        LOCATE 20, 4: PRINT "If you want to rest, or save...   "
                        LOCATE 21, 4: PRINT "Just stand in front of your bed   "
                        LOCATE 22, 4: PRINT "and press the enter key.          "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Harley:"
                        LOCATE 20, 4: PRINT "Now go... and defeat the Dark     "
                        LOCATE 21, 4: PRINT "Knight!                           "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Cooey:"
                        LOCATE 20, 4: PRINT "*grumble* Fine, fine... I'll do   "
                        LOCATE 21, 4: PRINT "that.                             "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                    ELSE
                        DialogBox
                        LOCATE 19, 4: PRINT "Harley:"
                        LOCATE 20, 4: PRINT "Nice job Cooey.  I wasn't sure if "
                        LOCATE 21, 4: PRINT "you had what it takes to defeat   "
                        LOCATE 22, 4: PRINT "knight.                           "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Harley:"
                        LOCATE 20, 4: PRINT "Right.  Well, I told you that I'd "
                        LOCATE 21, 4: PRINT "give you some more info if you    "
                        LOCATE 22, 4: PRINT "were successfull, so here goes... "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Harley:"
                        LOCATE 20, 4: PRINT "First... Stock up on Angel Wings. "
                        LOCATE 21, 4: PRINT "You can use them anywhere outside "
                        LOCATE 22, 4: PRINT "of battle to return to your house."
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Harley:"
                        LOCATE 20, 4: PRINT "Second... Your magic gains levels "
                        LOCATE 21, 4: PRINT "too.  If your spells gain enough, "
                        LOCATE 22, 4: PRINT "they will evolve into a stronger  "
                        LOCATE 23, 4: PRINT "spell.                            "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Harley:"
                        LOCATE 20, 4: PRINT "Finally... Should you die, you    "
                        LOCATE 21, 4: PRINT "will return to your house, where  "
                        LOCATE 22, 4: PRINT "you can rest, and then keep going."
                        LOCATE 23, 4: PRINT "You don't lose anything if you are"
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Harley:"
                        LOCATE 20, 4: PRINT "defeated, so don't be afraid to   "
                        LOCATE 21, 4: PRINT "take risks!                       "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                        DialogBox
                        LOCATE 19, 4: PRINT "Harley:"
                        LOCATE 20, 4: PRINT "Good luck Cooey!                  "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                END IF
            ELSEIF TalkTo$ = "James" THEN
                DialogBox
                LOCATE 19, 4: PRINT "James:"
                LOCATE 20, 4: PRINT "Argh! I still don't have a house! "
                LOCATE 21, 4: PRINT "C'mon... The town's bigger, the   "
                LOCATE 22, 4: PRINT "houses are bigger... and I'm still"
                LOCATE 23, 4: PRINT "homeless!                         "
                WHILE INKEY$ = "": LoopMIDI: WEND
            ELSEIF TalkTo$ = "Dark Knight" THEN
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "No, wait... Let me guess... You're"
                LOCATE 21, 4: PRINT "the Dark Knight, correct?         "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Dark Knight:"
                LOCATE 20, 4: PRINT "An astute observation.            "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Dark Knight:"
                LOCATE 20, 4: PRINT "However... It will be your last.  "
                LOCATE 21, 4: PRINT "For I shall dance upon your corpse"
                LOCATE 22, 4: PRINT "after I kill you!                 "
                WHILE INKEY$ = "": LoopMIDI: WEND
                StepsTaken% = 0: BossFight% = True: TalkTo$ = ""
                StopMIDI
                UnloadMIDI MIDIHandle%
                MIDIHandle% = LoadMIDI("BOSS.MID")
                PlayMIDI MIDIHandle%
                ShowArea
                Battle
                IF NOT Died% THEN
                    StopMIDI
                    UnloadMIDI MIDIHandle%
                    MIDIHandle% = LoadMIDI("MOUNTAIN.MID")
                    PlayMIDI MIDIHandle%
                END IF
                TalkTo$ = ""
            ELSEIF TalkTo$ = "Angelust" THEN
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "Who are you?                      "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Angelust:"
                LOCATE 20, 4: PRINT "We are the things that were and   "
                LOCATE 21, 4: PRINT "shall be again.                   "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "What do you want?                 "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Angelust:"
                LOCATE 20, 4: PRINT "We want what is yours...          "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Angelust:"
                LOCATE 20, 4: PRINT "LIFE!                             "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "Groovy.                           "
                WHILE INKEY$ = "": LoopMIDI: WEND
                StepsTaken% = 0: BossFight% = True: TalkTo$ = ""
                StopMIDI
                UnloadMIDI MIDIHandle%
                MIDIHandle% = LoadMIDI("BOSS.MID")
                PlayMIDI MIDIHandle%
                ShowArea
                Battle
                IF NOT Died% THEN
                    StopMIDI
                    UnloadMIDI MIDIHandle%
                    MIDIHandle% = LoadMIDI("TOWER_F1.MID")
                    PlayMIDI MIDIHandle%
                END IF
                TalkTo$ = ""
            ELSEIF TalkTo$ = "Soulrape" THEN
                DialogBox
                LOCATE 19, 4: PRINT "Soulrape:"
                LOCATE 20, 4: PRINT "Give... me... your... Soul...     "
                WHILE INKEY$ = "": LoopMIDI: WEND
                StepsTaken% = 0: BossFight% = True: TalkTo$ = ""
                StopMIDI
                UnloadMIDI MIDIHandle%
                MIDIHandle% = LoadMIDI("BOSS.MID")
                PlayMIDI MIDIHandle%
                ShowArea
                Battle
                IF NOT Died% THEN
                    StopMIDI
                    UnloadMIDI MIDIHandle%
                    MIDIHandle% = LoadMIDI("TOWER_F1.MID")
                    PlayMIDI MIDIHandle%
                END IF
                TalkTo$ = ""
            ELSEIF TalkTo$ = "Odin" THEN
                DialogBox
                LOCATE 19, 4: PRINT "Edenbeast:"
                LOCATE 20, 4: PRINT "Leave this place...               "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "What?                             "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "I will not leave until I find the "
                LOCATE 21, 4: PRINT "Dark Crystal.                     "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Edenbeast:"
                LOCATE 20, 4: PRINT "Then die...                       "
                WHILE INKEY$ = "": LoopMIDI: WEND
                StepsTaken% = 0: BossFight% = True: TalkTo$ = ""
                StopMIDI
                UnloadMIDI MIDIHandle%
                MIDIHandle% = LoadMIDI("BOSS.MID")
                PlayMIDI MIDIHandle%
                ShowArea
                Battle
                IF NOT Died% THEN
                    StopMIDI
                    UnloadMIDI MIDIHandle%
                    MIDIHandle% = LoadMIDI("TOWER_F1.MID")
                    PlayMIDI MIDIHandle%
                END IF
                TalkTo$ = ""
            ELSEIF TalkTo$ = "Urobulus" THEN
                DialogBox
                LOCATE 19, 4: PRINT "Urobulus:"
                LOCATE 20, 4: PRINT "I... am... the essence... of...   "
                LOCATE 21, 4: PRINT "life...                           "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "What?!                            "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Urobulus:"
                LOCATE 20, 4: PRINT "You... cannot defeat... me.       "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "We'll see about that!             "
                WHILE INKEY$ = "": LoopMIDI: WEND
                StepsTaken% = 0: BossFight% = True: TalkTo$ = ""
                StopMIDI
                UnloadMIDI MIDIHandle%
                MIDIHandle% = LoadMIDI("BOSS.MID")
                PlayMIDI MIDIHandle%
                ShowArea
                Battle
                IF NOT Died% THEN
                    StopMIDI
                    UnloadMIDI MIDIHandle%
                    MIDIHandle% = LoadMIDI("TOWER_F4.MID")
                    PlayMIDI MIDIHandle%
                END IF
                TalkTo$ = ""
            ELSEIF TalkTo$ = "Genesis God" THEN
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "Is this...                        "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "The Dark Crystal?                 "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "How do I collect this?            "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "Unless... I have to destroy it.   "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Genesis God:"
                LOCATE 20, 4: PRINT "Uruuuuuuuuuuuuuu....              "
                WHILE INKEY$ = "": LoopMIDI: WEND
                StepsTaken% = 0: BossFight% = True: TalkTo$ = ""
                StopMIDI
                UnloadMIDI MIDIHandle%
                MIDIHandle% = LoadMIDI("LASTBOSS.MID")
                PlayMIDI MIDIHandle%
                ShowArea
                Battle
                StopMIDI
                UnloadMIDI MIDIHandle%
                IF CooeyStory% = 6 THEN
                    StopMIDI
                    UnloadMIDI MIDIHandle%
                    MIDIHandle% = LoadMIDI("END.MID")
                    PlayMIDI MIDIHandle%
                    LoadTiles "cliffs.set", "tiles"
                    CurrentArea$ = "cliffs1.map"
                    CooeyX% = 7: CooeyY% = 5: CooeyDir% = 1: TopBar
                    LoadArea CurrentArea$
                    ShowArea
                    ShowCooey
                    BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Npcs%(2 * 202)), VARPTR(Npcs%(2 * 202)), 8 * 20, 5 * 20, 0
                    BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0
                    Delay 3
                    DialogBox
                    LOCATE 19, 4: PRINT "Cooey:"
                    LOCATE 20, 4: PRINT "Well...                           "
                    WHILE INKEY$ = "": LoopMIDI: WEND
                    DialogBox
                    LOCATE 19, 4: PRINT "Cooey:"
                    LOCATE 20, 4: PRINT "I guess its finally over.  The    "
                    LOCATE 21, 4: PRINT "Dark Crystal is no more.          "
                    WHILE INKEY$ = "": LoopMIDI: WEND
                    DialogBox
                    LOCATE 19, 4: PRINT "Dopey:"
                    LOCATE 20, 4: PRINT "Maybe now you can come home Cooey."
                    WHILE INKEY$ = "": LoopMIDI: WEND
                    DialogBox
                    LOCATE 19, 4: PRINT "Cooey:"
                    LOCATE 20, 4: PRINT "No.                               "
                    WHILE INKEY$ = "": LoopMIDI: WEND
                    DialogBox
                    LOCATE 19, 4: PRINT "Cooey:"
                    LOCATE 20, 4: PRINT "There is still more to do.        "
                    WHILE INKEY$ = "": LoopMIDI: WEND
                    DialogBox
                    LOCATE 19, 4: PRINT "Cooey:"
                    LOCATE 20, 4: PRINT "I have to go.                     "
                    WHILE INKEY$ = "": LoopMIDI: WEND
                    DialogBox
                    LOCATE 19, 4: PRINT "Dopey:"
                    LOCATE 20, 4: PRINT "Well, you're not leaving me here. "
                    LOCATE 21, 4: PRINT "I'm coming with you!              "
                    WHILE INKEY$ = "": LoopMIDI: WEND
                    DialogBox
                    LOCATE 19, 4: PRINT "Cooey:"
                    LOCATE 20, 4: PRINT "Eeek.                             "
                    WHILE INKEY$ = "": LoopMIDI: WEND
                    Ending
                END IF
            ELSEIF TalkTo$ = "Cain" THEN
                DialogBox
                LOCATE 19, 4: PRINT "Cain:"
                LOCATE 20, 4: PRINT "Ah... You've found me.  I commend "
                LOCATE 21, 4: PRINT "your efforts.                     "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "Yeah? Who are you?                "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cain:"
                LOCATE 20, 4: PRINT "My name, is Baron Cain... and I   "
                LOCATE 21, 4: PRINT "hold the secret of the Dark Crown."
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cain:"
                LOCATE 20, 4: PRINT "You may have its secrets...       "
                WHILE INKEY$ = "": LoopMIDI: WEND
                DialogBox
                LOCATE 19, 4: PRINT "Cain:"
                LOCATE 20, 4: PRINT "If you can defeat me.             "
                WHILE INKEY$ = "": LoopMIDI: WEND
                StepsTaken% = 0: BossFight% = True
                StopMIDI
                UnloadMIDI MIDIHandle%
                MIDIHandle% = LoadMIDI("BOSS.MID")
                PlayMIDI MIDIHandle%
                ShowArea
                Battle
                IF NOT Died% THEN
                    StopMIDI
                    UnloadMIDI MIDIHandle%
                    MIDIHandle% = LoadMIDI("SECRET.MID")
                    PlayMIDI MIDIHandle%
                END IF
                TalkTo$ = ""
            ELSEIF TalkTo$ = "Cooey" THEN
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "Yawn... Hmm... Maybe I should rest"
                LOCATE 21, 4: PRINT "up.                               "
                ChoiceBox
                IF Decision% THEN
                        HP% = MaxHP%
                        MP% = MaxMP%
                        TopBar
                        ShowArea
                        ShowCooey
                        BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0
                        DialogBox
                        LOCATE 19, 4: PRINT "Cooey:"
                        LOCATE 20, 4: PRINT "Ahh... Refresing!                 "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                    ELSE
                        ShowArea
                        ShowCooey
                        BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0
                END IF
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "Hmm... Should I save my game?     "
                ChoiceBox
                IF Decision% THEN
                        OPEN "soc2.sav" FOR OUTPUT AS #2
                        WRITE #2, HP%, MaxHP%, MP%, MaxMP%, ST%, DF%, AG%, MS%, MD%, Ex!, NextEx!, Level%, TimeOn!, CooeyStory%, CooeySecret%
                        FOR I = 0 TO 4
                            WRITE #2, Magic$(I), MagicLvl%(I), MagicEx%(I), Item$(I), ItemQnt%(I)
                        NEXT I
                        FOR I = 1 TO 22
                            WRITE #2, ChestArea$(I), ChestX%(I), ChestY%(I), ChestItem$(I)
                        NEXT I
                        WRITE #2, Weapon$, Armor$
                        CLOSE #2
                        ShowArea
                        ShowCooey
                        BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0
                        DialogBox
                        LOCATE 19, 4: PRINT "Cooey:"
                        LOCATE 20, 4: PRINT "There.  My progress has been      "
                        LOCATE 21, 4: PRINT "recorded.                         "
                        WHILE INKEY$ = "": LoopMIDI: WEND
                    ELSE
                        ShowArea
                        ShowCooey
                        BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0
                END IF
                DialogBox
                LOCATE 19, 4: PRINT "Cooey:"
                LOCATE 20, 4: PRINT "Well... Time to get on with my    "
                LOCATE 21, 4: PRINT "adventure.                        "
                WHILE INKEY$ = "": LoopMIDI: WEND
        END IF
    CASE CHR$(27)
        quit = True
    END SELECT

    IF LEFT$(CurrentArea$, 4) <> "town" AND Moved% AND StepsTaken% > 6 THEN
        Fight% = INT(RND * 6)
        IF Fight% = 2 THEN
            StepsTaken% = 0
            StopMIDI
            UnloadMIDI MIDIHandle%
            MIDIHandle% = LoadMIDI("BATTLE.MID")
            PlayMIDI MIDIHandle%
            ShowArea
            Battle
            TalkTo$ = ""
            IF NOT Died% THEN
                IF LEFT$(CurrentArea$, 6) = "forest" THEN
                        StopMIDI
                        UnloadMIDI MIDIHandle%
                        MIDIHandle% = LoadMIDI("FOREST.MID")
                        PlayMIDI MIDIHandle%
                    ELSEIF LEFT$(CurrentArea$, 6) = "cliffs" THEN
                        StopMIDI
                        UnloadMIDI MIDIHandle%
                        MIDIHandle% = LoadMIDI("MOUNTAIN.MID")
                        PlayMIDI MIDIHandle%
                    ELSEIF LEFT$(CurrentArea$, 1) = "f" AND LEN(CurrentArea$) < 10 THEN
                        StopMIDI
                        UnloadMIDI MIDIHandle%
                        Temp$ = LEFT$(CurrentArea$, 2)
                        IF Temp$ = "f1" OR Temp$ = "f2" OR Temp$ = "f3" THEN
                                MIDIHandle% = LoadMIDI("TOWER_F1.MID")
                            ELSEIF Temp$ = "f4" OR Temp$ = "f5" THEN
                                IF CurrentArea$ = "f4_1.map" OR CurrentArea$ = "f4_4.map" THEN
                                        MIDIHandle% = LoadMIDI("SECRET.MID")
                                    ELSE
                                        MIDIHandle% = LoadMIDI("TOWER_F4.MID")
                                END IF
                        END IF
                        PlayMIDI MIDIHandle%
                END IF
            END IF
        END IF
    END IF

    IF Moved% THEN
        StepsTaken% = StepsTaken% + 1
        ShowArea
        ShowCooey
        BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0
    END IF
    LoopMIDI

    IF LEFT$(CurrentArea$, 1) = "f" AND LEN(CurrentArea$) < 10 THEN
        IF CurrentArea$ <> "f4_1.map" AND CurrentArea$ <> "f4_4.map" THEN
            FOR Y% = 1 TO 9
                FOR X% = 0 TO 15
                    IF Map(X%, Y%) = 30 THEN
                        IF Flag1% = 0 THEN
                                BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Tiles%(Map(X%, Y%) * 202)), VARPTR(Tiles%(30 * 202)), X% * 20, Y% * 20, 0
                                IF Flicker! + .25 < TIMER THEN
                                    Flag1% = 1: Flicker! = TIMER
                                END IF
                            ELSEIF Flag1% = 1 THEN
                                BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Tiles%(Map(X%, Y%) * 202)), VARPTR(Tiles%(31 * 202)), X% * 20, Y% * 20, 0
                                IF Flicker! + .25 < TIMER THEN
                                    Flag1% = 0: Flicker! = TIMER
                                END IF
                        END IF
                    END IF
                NEXT X%
            NEXT Y%
            BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0
        END IF
    END IF
    Moved% = False

LOOP UNTIL quit

StopMIDI
UnloadMIDI MIDIHandle%
CleanUpMIDI
ClosingMessage
SYSTEM

REM $DYNAMIC
SUB InitLib
  '
  ' BlastCopy! (BLSTCOPY.ASM)
  '
  code$ = "1E5589E58B460E8ED88B760C8B460A8EC08B7E08B9007DF3A55D1FCA0800"
  '
  DEF SEG = VARSEG(code1%(0))
  '
  FOR I% = 0 TO 29
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code1%(0)) + I%, d%
  NEXT I%
  '
  DEF SEG
  '
  ' BlastPset! (BLSTPSET.ASM)
  '
  code$ = "1E5589E58B46108ED88B760AB106D3E689F3B102D3E601DE8B5E0C01DE8B5E0E01DE8A460888045D1FCA0A00"
  '
  DEF SEG = VARSEG(code2%(0))
  '
  FOR I% = 0 TO 43
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code2%(0)) + I%, d%
  NEXT I%
  '
  DEF SEG
  '
  ' BlastPut! (BLASTPUT.ASM)
  '
  code$ = "1E5589E58B460C508B460A508B46108ED88B760E8B04B103D3E8508B5EFE"
  code$ = code$ + "01C3895EFE8B4402508B5EFC01C3895EFC83C60489760E89E58B46188ED8"
  code$ = code$ + "8B76168A04468976163A461074208B5E1C8EDB8B7612B106D3E689F3B102"
  code$ = code$ + "D3E601DE8B5E1401DE8B5E1A01DE88048B4614408946148B460639461475"
  code$ = code$ + "BE8B46142B46028946148B4612408946128B460439461275A6585858585D"
  code$ = code$ + "1FCA0E00"
  '
  DEF SEG = VARSEG(code3%(0))
  '
  FOR I% = 0 TO 153
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code3%(0)) + I%, d%
  NEXT I%
  '
  DEF SEG
  '
  ' BlastGet! (BLASTGET.ASM)
  '
  code$ = "1E5589E58B460A508B4608508B460A2B460E40508B46082B460C40508B46128ED8"
  code$ = code$ + "8B76108B46FABB0800F7E3890446468B46F88904464689761089E58B5E"
  code$ = code$ + "1E8EDB8B7614B106D3E689F3B102D3E601DE8B5E1601DE8B5E1C01DE8A"
  code$ = code$ + "048B5E1A8EDB8B76188804468976188B4616408946168B460639461676"
  code$ = code$ + "C38B46162B46028946168B4614408946148B460439461476AB58585858"
  code$ = code$ + "5D1FCA1000"
  '
  DEF SEG = VARSEG(code4%(0))
  '
  FOR I% = 0 TO 153
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code4%(0)) + I%, d%
  NEXT I%
  '
  DEF SEG
  '
  ' BlastCLS! (BLASTCLS.ASM)
  '
  code$ = "1E5589E58B460C8ED88B760A8B460888C4B900FA890483C60283E90275F65D1FCA0600"
  '
  DEF SEG = VARSEG(code6%(0))
  '
  FOR I% = 0 TO 34
    d% = VAL("&h" + MID$(code$, I% * 2 + 1, 2))
    POKE VARPTR(code6%(0)) + I%, d%
  NEXT I%
  '
  DEF SEG
  '
END SUB

SUB Intro

    DEF SEG = &HA000
    BLOAD "logo.fsi"
    Delay 3
    MIDIHandle% = LoadMIDI("INTRO.MID")

    Text1$ = "      Guided by the Wind Spirit,       "
    Text2$ = "   Cooey defeated the Ancient Omen.    "
    Text3$ = "                                       "
    Text4$ = "He retrieved the Mystic Cooey Statue..."
    Text5$ = "    and restored peace and balance     "
    Text6$ = "             to the land.              "
    Text7$ = "                                       "
    Text8$ = "            All was well.              "
    Text9$ = "          Or so it seemed...           "
    Text10$ = "                                       "
    Text11$ = "           Out of nowhere,             "
    Text12$ = "     an ominous tower appeared         "
    Text13$ = " where the Castle of Flame once stood. "
    Text14$ = "                                       "
    Text15$ = "      In it... The Dark Crystal,       "
    Text16$ = "     guarded by fearsome demons,       "
    Text17$ = "reflected an eerie glow upon the land.."

    PlayMIDI MIDIHandle%
    FOR Y% = 216 TO 45 STEP -1
        PutSprite "intro1.bak", 86, 53, 0
        BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 8, Text1$, 15
        BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 7, Text2$, 15
        BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 6, Text3$, 15
        BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 5, Text4$, 15
        BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 4, Text5$, 15
        BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 3, Text6$, 15
        BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 2, Text7$, 15
        BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 1, Text8$, 15
        BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 0, Text9$, 15
        FOR X% = 0 TO 319 STEP 20
            PutSprite "blank.til", X%, 151, 0
            PutSprite "blank.til", X%, 171, 0
            PutSprite "blank.til", X%, 10, 0
        NEXT X%
        BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0
        LoopMIDI
        Delay .05
        BlastCLS VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0
        IF INKEY$ <> "" THEN
            KeyPressed = True
            EXIT FOR
        END IF
    NEXT Y%
    IF NOT KeyPressed THEN
        FOR Y% = 208 TO 45 STEP -1
            PutSprite "intro2.bak", 86, 53, 0
            BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 7, Text10$, 15
            BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 6, Text11$, 15
            BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 5, Text12$, 15
            BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 4, Text13$, 15
            BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 3, Text14$, 15
            BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 2, Text15$, 15
            BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 1, Text16$, 15
            BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y% - 8 * 0, Text17$, 15
            FOR X% = 0 TO 319 STEP 20
                PutSprite "blank.til", X%, 151, 0
                PutSprite "blank.til", X%, 171, 0
                PutSprite "blank.til", X%, 10, 0
            NEXT X%
            BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0
            LoopMIDI
            Delay .05
            BlastCLS VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0
            IF INKEY$ <> "" THEN EXIT FOR
        NEXT Y%
    END IF

END SUB

SUB LoadArea (Area$)

    StepsTaken% = 0
    OPEN Area$ FOR INPUT AS #2
    FOR Y% = 1 TO 9
        INPUT #2, Map%(0, Y%), Map%(1, Y%), Map%(2, Y%), Map%(3, Y%), Map%(4, Y%), Map%(5, Y%), Map%(6, Y%), Map(7, Y%), Map(8, Y%), Map(9, Y%), Map(10, Y%), Map(11, Y%), Map(12, Y%), Map(13, Y%), Map(14, Y%), Map(15, Y%)
    NEXT Y%
    CLOSE #2

END SUB

SUB LoadData (DataType$)

    OPEN "levelup.dat" FOR INPUT AS #2
    FOR I = 1 TO 30
        INPUT #2, LevelUp!(I)
    NEXT I
    CLOSE #2

    OPEN "chests.dat" FOR INPUT AS #2
    FOR I = 1 TO 22
        INPUT #2, ChestArea$(I), ChestX%(I), ChestY%(I), ChestItem$(I)
    NEXT I
    CLOSE #2

END SUB

SUB LoadTiles (Filename$, TileSet$)

    IF TileSet$ = "tiles" THEN
            DEF SEG = VARSEG(Tiles%(0))
            BLOAD Filename$, VARPTR(Tiles%(0))
        ELSEIF TileSet$ = "cooey" THEN
            DEF SEG = VARSEG(Cooey%(0))
            BLOAD Filename$, VARPTR(Cooey%(0))
        ELSEIF TileSet$ = "npcs" THEN
            DEF SEG = VARSEG(Npcs%(0))
            BLOAD Filename$, VARPTR(Npcs%(0))
    END IF
    DEF SEG

END SUB

SUB MenuBox

    LINE (20, 40)-(200, 180), 185, B
    LINE (21, 41)-(199, 179), 114, B
    LINE (22, 42)-(198, 178), 185, B
    LINE (23, 43)-(197, 177), 0, BF

END SUB

SUB MoveCooey (CooeyDir%)

    IF CooeyDir% = 0 THEN
            FOR Y% = CooeyY% * 20 TO CooeyY% * 20 - 20 STEP -2
                ShowArea
                IF NewWalk% = 3 THEN
                    IF WalkType% = 0 THEN WalkType% = 1 ELSE IF WalkType% = 1 THEN WalkType% = 2 ELSE IF WalkType% = 2 THEN WalkType% = 0
                    NewWalk% = 0
                END IF
                NewWalk% = NewWalk% + 1
                LoopMIDI
                BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Cooey%((3 + WalkType%) * 202)), VARPTR(Cooey%((3 + WalkType%) * 202)), CooeyX% * 20, Y%, 0
                BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0
            NEXT Y%
            CooeyY% = CooeyY% - 1
        ELSEIF CooeyDir% = 1 THEN
            FOR Y% = CooeyY% * 20 TO CooeyY% * 20 + 20 STEP 2
                ShowArea
                IF NewWalk% = 3 THEN
                    IF WalkType% = 0 THEN WalkType% = 1 ELSE IF WalkType% = 1 THEN WalkType% = 2 ELSE IF WalkType% = 2 THEN WalkType% = 0
                    NewWalk% = 0
                END IF
                NewWalk% = NewWalk% + 1
                LoopMIDI
                BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Cooey%((0 + WalkType%) * 202)), VARPTR(Cooey%((0 + WalkType%) * 202)), CooeyX% * 20, Y%, 0
                BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0
            NEXT Y%
            CooeyY% = CooeyY% + 1
        ELSEIF CooeyDir% = 2 THEN
            FOR X% = CooeyX% * 20 TO CooeyX% * 20 - 20 STEP -2
                ShowArea
                IF NewWalk% = 3 THEN
                    IF WalkType% = 0 THEN WalkType% = 1 ELSE IF WalkType% = 1 THEN WalkType% = 2 ELSE IF WalkType% = 2 THEN WalkType% = 0
                    NewWalk% = 0
                END IF
                NewWalk% = NewWalk% + 1
                LoopMIDI
                BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Cooey%((9 + WalkType%) * 202)), VARPTR(Cooey%((9 + WalkType%) * 202)), X%, CooeyY% * 20, 0
                BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0
            NEXT X%
            CooeyX% = CooeyX% - 1
        ELSEIF CooeyDir% = 3 THEN
            FOR X% = CooeyX% * 20 TO CooeyX% * 20 + 20 STEP 2
                ShowArea
                IF NewWalk% = 3 THEN
                    IF WalkType% = 0 THEN WalkType% = 1 ELSE IF WalkType% = 1 THEN WalkType% = 2 ELSE IF WalkType% = 2 THEN WalkType% = 0
                    NewWalk% = 0
                END IF
                NewWalk% = NewWalk% + 1
                LoopMIDI
                BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Cooey%((6 + WalkType%) * 202)), VARPTR(Cooey%((6 + WalkType%) * 202)), X%, CooeyY% * 20, 0
                BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0
            NEXT X%
            CooeyX% = CooeyX% + 1
    END IF

END SUB

SUB PreEnd


END SUB

SUB PutSprite (Filename$, X%, Y%, Number%)

    DEF SEG = VARSEG(Sprite%(0))
    BLOAD Filename$, VARPTR(Sprite%(0))

    BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Sprite%(202 * Number%)), VARPTR(Sprite%(202 * Number%)), X%, Y%, 0
    DEF SEG

END SUB

SUB ShowArea

    FullScreen% = True
    DEF SEG = VARSEG(Buffer%(0))
    IF CurrentArea$ = "cliffs1.map" THEN
            BLOAD "back1.fsi", VARPTR(Buffer%(0))
            TopBar
        ELSEIF CurrentArea$ = "cliffs2.map" THEN
            BLOAD "back2.fsi", VARPTR(Buffer%(0))
            TopBar
        ELSEIF CurrentArea$ = "cliffs3.map" THEN
            BLOAD "back3.fsi", VARPTR(Buffer%(0))
            TopBar
        ELSEIF CurrentArea$ = "f5_3.map" THEN
            BLOAD "final.fsi", VARPTR(Buffer%(0))
            TopBar
    END IF
    DEF SEG
    FullScreen% = False

    FOR Y% = 1 TO 9
        FOR X% = 0 TO 15
            BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Tiles%(Map(X%, Y%) * 202)), VARPTR(Tiles%(Map(X%, Y%) * 202)), X% * 20, Y% * 20, 0
            IF Map%(X%, Y%) = 43 THEN
                FOR I% = 1 TO 22
                    IF ChestX%(I%) = X% AND ChestY%(I%) = Y% AND CurrentArea$ = ChestArea$(I%) THEN
                        IF ChestItem$(I%) <> "" THEN
                                BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Tiles%(43 * 202)), VARPTR(Tiles%(43 * 202)), X% * 20, Y% * 20, 0
                            ELSE
                                BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Tiles%(42 * 202)), VARPTR(Tiles%(42 * 202)), X% * 20, Y% * 20, 0
                        END IF
                    END IF
                NEXT I%
            END IF
            IF CurrentArea$ = "town2.map" THEN
                    IF X% = 12 AND Y% = 3 THEN
                            BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Npcs%(1 * 202)), VARPTR(Npcs%(1 * 202)), X% * 20, Y% * 20, 0
                        ELSEIF X% = 11 AND Y% = 3 THEN
                            BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Npcs%(1 * 202)), VARPTR(Npcs%(0 * 202)), X% * 20, Y% * 20, 0
                    END IF
                ELSEIF CurrentArea$ = "town3.map" THEN
                    IF X% = 7 AND Y% = 4 THEN
                        BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Npcs%(2 * 202)), VARPTR(Npcs%(2 * 202)), X% * 20, Y% * 20, 0
                    END IF
                ELSEIF CurrentArea$ = "town4.map" THEN
                    IF X% = 5 AND Y% = 4 THEN
                            BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Npcs%(3 * 202)), VARPTR(Npcs%(3 * 202)), X% * 20, Y% * 20, 0
                        ELSEIF X% = 9 AND Y% = 3 THEN
                            BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Npcs%(4 * 202)), VARPTR(Npcs%(4 * 202)), X% * 20, Y% * 20, 0
                    END IF
                ELSEIF CurrentArea$ = "cliffs1.map" AND CooeyStory% = 0 AND BossFight% = False THEN
                    IF X% = 15 AND Y% = 5 THEN PutSprite "darkknig.til", X * 20, Y * 20, 0
                ELSEIF CurrentArea$ = "f1_5.map" AND CooeyStory% = 1 AND BossFight% = False THEN
                    IF X% = 7 AND Y% = 6 THEN PutSprite "angelust.til", X * 20, Y * 20, 0
                ELSEIF CurrentArea$ = "f2_1.map" AND CooeyStory% = 2 AND BossFight% = False THEN
                    IF X% = 11 AND Y% = 3 THEN PutSprite "soulrape.til", X * 20, Y * 20, 0
                ELSEIF CurrentArea$ = "f3_4.map" AND CooeyStory% = 3 AND BossFight% = False THEN
                    IF X% = 4 AND Y% = 3 THEN PutSprite "edenbeas.til", X * 20, Y * 20, 0
                ELSEIF CurrentArea$ = "f4_3.map" AND CooeyStory% = 4 AND BossFight% = False THEN
                    IF X% = 8 AND Y% = 3 THEN PutSprite "urobulus.til", X * 20, Y * 20, 0
                ELSEIF CurrentArea$ = "f4_4.map" AND CooeySecret% = 0 AND BossFight% = False THEN
                    IF X% = 7 AND Y% = 3 THEN PutSprite "cain.til", X * 20, Y * 20, 0
                ELSEIF CurrentArea$ = "f5_3.map" AND CooeyStory% = 5 AND BossFight% = False THEN
                    IF X% = 7 AND Y% = 5 THEN PutSprite "genesisg.til", X * 20, Y * 20, 0
            END IF
            IF LEFT$(CurrentArea$, 1) = "f" AND LEN(CurrentArea$) < 10 THEN
                IF CurrentArea$ <> "f4_1.map" AND CurrentArea$ <> "f4_4.map" THEN
                        IF Map(X%, Y%) = 33 THEN
                                BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Tiles%(Map(X%, Y%) * 202)), VARPTR(Tiles%(0 * 202)), X% * 20, Y% * 20, 0
                                BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Tiles%(Map(X%, Y%) * 202)), VARPTR(Tiles%(33 * 202)), X% * 20, Y% * 20, 0
                            ELSEIF Map(X%, Y%) = 35 THEN
                                BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Tiles%(Map(X%, Y%) * 202)), VARPTR(Tiles%(1 * 202)), X% * 20, Y% * 20, 0
                                BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Tiles%(Map(X%, Y%) * 202)), VARPTR(Tiles%(35 * 202)), X% * 20, Y% * 20, 0
                            ELSEIF Map(X%, Y%) = 30 THEN
                                IF Flag1% = 0 THEN
                                        BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Tiles%(Map(X%, Y%) * 202)), VARPTR(Tiles%(30 * 202)), X% * 20, Y% * 20, 0
                                        IF Flicker! + .25 < TIMER THEN
                                            Flag1% = 1: Flicker! = TIMER
                                        END IF
                                    ELSEIF Flag1% = 1 THEN
                                        BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Tiles%(Map(X%, Y%) * 202)), VARPTR(Tiles%(31 * 202)), X% * 20, Y% * 20, 0
                                        IF Flicker! + .25 < TIMER THEN
                                            Flag1% = 0: Flicker! = TIMER
                                        END IF
                                END IF
                        END IF
                    ELSE
                        IF Map(X%, Y%) = 1 THEN
                            BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Tiles%(Map(X%, Y%) * 202)), VARPTR(Tiles%(31 * 202)), X% * 20, Y% * 20, 0
                            BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Tiles%(Map(X%, Y%) * 202)), VARPTR(Tiles%(1 * 202)), X% * 20, Y% * 20, 0
                        END IF
                END IF
            END IF
        NEXT X%
    NEXT Y%

END SUB

SUB ShowCooey

    IF CooeyDir% = 0 THEN
            BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Cooey%(3 * 202)), VARPTR(Cooey%(3 * 202)), CooeyX% * 20, CooeyY% * 20, 0
        ELSEIF CooeyDir% = 1 THEN
            BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Cooey%(0 * 202)), VARPTR(Cooey%(0 * 202)), CooeyX% * 20, CooeyY% * 20, 0
        ELSEIF CooeyDir% = 2 THEN
            BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Cooey%(9 * 202)), VARPTR(Cooey%(9 * 202)), CooeyX% * 20, CooeyY% * 20, 0
        ELSEIF CooeyDir% = 3 THEN
            BlastPut VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), VARSEG(Cooey%(6 * 202)), VARPTR(Cooey%(6 * 202)), CooeyX% * 20, CooeyY% * 20, 0
    END IF

END SUB

SUB ShowCooeyMenu

    LINE (230, 40)-(300, 110), 185, B
    LINE (231, 41)-(299, 109), 114, B
    LINE (232, 42)-(298, 108), 185, B
    LINE (233, 43)-(297, 107), 0, BF

    LOCATE 7, 32: PRINT "Item"
    LOCATE 9, 32: PRINT "Magic"
    LOCATE 11, 32: PRINT "Stats"
    LOCATE 13, 32: PRINT "Return"

    LINE (230, 145)-(300, 180), 185, B
    LINE (231, 146)-(299, 179), 114, B
    LINE (232, 147)-(298, 178), 185, B
    LINE (233, 148)-(297, 177), 0, BF

    GetTimePlayed
    LOCATE 20, 31: PRINT "Played"
    LOCATE 22, 33: PRINT TimePlayed$

END SUB

SUB TitleScreen

    DEF SEG = &HA000
    BLOAD "title.fsi"
    DEF SEG
    PointerX% = 12: PointerY% = 16
    LOCATE 16, 14: PRINT "New Journey"
    LOCATE 18, 14: PRINT "Load Journey"
    COLOR 4
    LOCATE 16, 12: PRINT ""

    DO
        LoopMIDI
        SELECT CASE INKEY$
        CASE CHR$(0) + CHR$(80)
            LOCATE PointerY%, PointerX%: PRINT " "
            PointerY% = PointerY% - 2
            IF PointerY% = 14 THEN PointerY% = 18
            LOCATE PointerY%, PointerX%: PRINT ""
        CASE CHR$(0) + CHR$(72)
            LOCATE PointerY%, PointerX%: PRINT " "
            PointerY% = PointerY% + 2
            IF PointerY% = 20 THEN PointerY% = 16
            LOCATE PointerY%, PointerX%: PRINT ""
        CASE CHR$(13)
            Chosen% = True: TimeStarted! = TIMER
            CooeyX% = 9: CooeyY% = 4: CooeyDir% = 1
            IF PointerY% = 16 THEN
                    COLOR 15
                    StopMIDI
                    UnloadMIDI MIDIHandle%
                    Level% = 1
                    MaxHP% = 30: MaxMP% = 5
                    HP% = MaxHP%: MP% = MaxMP%
                    ST% = 5: DF% = 6: AG% = 5: MS% = 5: MD% = 5: NextEx! = 10
                    Weapon$ = "Fists": Armor$ = "Clothes"
                    TotalTime! = 0: TimeOn! = 0
                    TopBar
                    ShowArea
                    ShowCooey
                    BlastCopy VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), &HA000, 0
                    DialogBox
                    LOCATE 19, 4: PRINT "Cooey:"
                    LOCATE 20, 4: PRINT "Hrm... That tower just appeared   "
                    LOCATE 21, 4: PRINT "out of nowhere!                   "
                    WHILE INKEY$ = "": WEND
                    DialogBox
                    LOCATE 19, 4: PRINT "Cooey:"
                    LOCATE 20, 4: PRINT "I'd better go check it out.       "
                    WHILE INKEY$ = "": WEND
                    DialogBox
                    LOCATE 19, 4: PRINT "Cooey:"
                    LOCATE 20, 4: PRINT "But first... I'd better talk to   "
                    LOCATE 21, 4: PRINT "everyone in town to make sure     "
                    LOCATE 22, 4: PRINT "they're allright.                 "
                    WHILE INKEY$ = "": WEND
                    DialogBox
                    LOCATE 19, 4: PRINT "Cooey:"
                    LOCATE 20, 4: PRINT "Well... Time to get going!        "
                    WHILE INKEY$ = "": WEND
                ELSEIF PointerY% = 18 THEN
                    StopMIDI
                    UnloadMIDI MIDIHandle%
                    OPEN "soc2.sav" FOR INPUT AS #2
                    INPUT #2, HP%, MaxHP%, MP%, MaxMP%, ST%, DF%, AG%, MS%, MD%, Ex!, NextEx!, Level%, TimeOn!, CooeyStory%, CooeySecret%
                    FOR I = 0 TO 4
                        INPUT #2, Magic$(I), MagicLvl%(I), MagicEx%(I), Item$(I), ItemQnt%(I)
                    NEXT I
                    FOR I = 1 TO 22
                        INPUT #2, ChestArea$(I), ChestX%(I), ChestY%(I), ChestItem$(I)
                    NEXT I
                    INPUT #2, Weapon$, Armor$
                    CLOSE #2
            END IF
        END SELECT
    LOOP UNTIL Chosen%
    COLOR 15

END SUB

SUB TopBar

    FOR X% = 0 TO 319
        BlastPset VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), X%, 0, 185
        BlastPset VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), X%, 19, 185
    NEXT X%
    FOR Y% = 1 TO 18
        BlastPset VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 0, Y%, 185
        BlastPset VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 319, Y%, 185
    NEXT Y%
    FOR X% = 1 TO 318
        BlastPset VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), X%, 1, 114
        BlastPset VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), X%, 18, 114
    NEXT X%
    FOR Y% = 2 TO 17
        BlastPset VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 1, Y%, 114
        BlastPset VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 318, Y%, 114
    NEXT Y%
    FOR X% = 2 TO 317
        BlastPset VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), X%, 2, 185
        BlastPset VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), X%, 17, 185
    NEXT X%
    FOR Y% = 3 TO 16
        BlastPset VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 2, Y%, 185
        BlastPset VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 317, Y%, 185
    NEXT Y%
    IF NOT FullScreen% THEN
        FOR Y% = 4 TO 15
            FOR X% = 3 TO 316
                BlastPset VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), X%, Y%, 0
            NEXT X%
        NEXT Y%
    END IF
    Text$ = RIGHT$(STR$(HP%), 3)
    BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 5, 7, Text$, 15
    BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 30, 7, "/", 15
    Text$ = RIGHT$(STR$(MaxHP%), 3)
    BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 39, 7, Text$, 15
    Text$ = RIGHT$(STR$(MP%), 2)
    BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 80, 7, Text$, 10
    BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 97, 7, "/", 15
    Text$ = RIGHT$(STR$(MaxMP%), 2)
    BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 106, 7, Text$, 10

    IF LEFT$(CurrentArea$, 4) = "town" THEN
            Text$ = "Wind Town"
        ELSEIF LEFT$(CurrentArea$, 6) = "forest" THEN
            Text$ = "Coo Forest"
        ELSEIF LEFT$(CurrentArea$, 6) = "cliffs" THEN
            Text$ = "Eternal Mountain"
        ELSEIF LEFT$(CurrentArea$, 2) = "f1" THEN
            Text$ = "Dark Tower 1F"
        ELSEIF LEFT$(CurrentArea$, 2) = "f2" THEN
            Text$ = "Dark Tower 2F"
        ELSEIF LEFT$(CurrentArea$, 2) = "f3" THEN
            Text$ = "Dark Tower 3F"
        ELSEIF LEFT$(CurrentArea$, 2) = "f4" THEN
            IF CurrentArea$ = "f4_1.map" OR CurrentArea$ = "f4_4.map" THEN
                    Text$ = "Secret Area!"
                ELSE
                    Text$ = "Dark Tower 4F"
            END IF
        ELSEIF LEFT$(CurrentArea$, 2) = "f5" THEN
            IF CurrentArea$ = "f5_3.map" THEN
                    Text$ = "The Dark Crystal"
                ELSE
                    Text$ = "Final Floor"
            END IF
    END IF
    IF NOT FullScreen% THEN
        FOR Y% = 7 TO 15
            FOR X% = 160 TO 260
                BlastPset VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), X%, Y%, 0
            NEXT X%
        NEXT Y%
    END IF
    BlastPrint VARSEG(Buffer%(0)), VARPTR(Buffer%(0)), 160, 7, Text$, 15

END SUB

